/*

STM to SCALA conversion functions

Ian Scott (ian@norcimo.com)

Version 2.0 (March 2002)

*/



/* You may freely copy, redistribute and modify this code for non-commercial purposes provided you acknowledge the original author and make freely available, under identical conditions and restrictions, all code thus produced  */



/*

Functions for use in converting STM files

*/





#include <iostream.h>

#include <string.h>

#include <stdio.h>

#include <fstream.h>



#include "util.h"

#include "stm2scalaf.h"

// #define DEBUG



/********************************************************************

*********Routine to check which syntax is being used*****************

********************************************************************/



SYNTYPE syncheck(int argc, char* argv[])

{

if (argc==1)

	return ALL;  //stm2scala



if (argc==2)

	{

	if (!strcmp(argv[1],"help") || !strcmp(argv[1],"?"))

		return HELP; //stm2scala help or stm2scala ?

	return LIST; //stm2scala <file>

	}



if (argc==3)

	{

	if (strcmp(argv[2],"-") && strcmp(argv[1],"-"))

		return LIST; //stm2scala <file> <file>

	if (!strcmp(argv[1],"-"))

		return UPWARD; //stm2scala - <file>

	return ONWARD; //stm2scala <file> -

	}



if (argc==4)

	if (!strcmp(argv[2],"-"))

		return RANGE; //stm2scala <file> - <file>



return LIST; //stm2scala <filelist>

} //end syncheck



/********************************************************************

*********Routine to find the next available file from the ***********

*********current one. Returns -1 if max file exceeded***************/







int nextfile(char* currfile, int maxfile)

{

int cf;

char fname[255];

cf=atoi(currfile);

ifstream testfile;

while (cf<=maxfile)

{

      cf++;

      strcpy(fname,"tp");

      itoa(cf,currfile);

      strcat(fname,currfile);

      testfile.open(fname,ios::binary|ios::in|ios::nocreate);

      if (testfile)

      		break;

}

if (testfile)

	{

	testfile.close();

	return cf;

	}

else

	return 0;

}





