/* util.cpp */
/* Ian Scott (ian@norcimo.com) */
/* Version 2.2 March 2002*/
/* Original July 2000 (v1.0)*/

/* You may freely copy, redistribute and modify this code for non-commercial purposes provided you acknowledge the original author and make freely available, under identical conditions and restrictions, all code thus produced  */

/* Set of util routines */

#include "util.h"
#include <string.h>
#include <iostream.h>
#include <math.h>
#include <iostream.h>
#include <ctype.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>

#ifndef boolian
#define boolian
enum BOOL {FALSE,TRUE};
#endif

/* integer to ascii decimal - converts an integer to an ascii string */

char* itoa(int integer)

{
int number = 0, i = 0, j = 0;
char tempNum;
char* textNum;

if (integer >= 0) { number = integer; }
else { number = -integer; }

/* convert integer values to characters from right to left */

do {
    textNum[j++] = (number % 10) + '0';
    number /= 10;
} while (number != 0);

if (integer < 0) { textNum[j++] = '-'; }

textNum[j--] = '\0';

/* reverse the array since it was written backwards */

while (i < j) {
    tempNum = textNum[i];
    textNum[i++] = textNum[j];
    textNum[j--] = tempNum;
}

return textNum;
}

int itoa(int integer,char* textNum)

{
int number = 0, i = 0, j = 0;
char tempNum;

if (integer >= 0) { number = integer; }
else { number = -integer; }

/* convert integer values to characters from right to left */

do {
    textNum[j++] = (number % 10) + '0';
    number /= 10;
} while (number != 0);

if (integer < 0) { textNum[j++] = '-'; }

textNum[j--] = '\0';

/* reverse the array since it was written backwards */

while (i < j) {
    tempNum = textNum[i];
    textNum[i++] = textNum[j];
    textNum[j--] = tempNum;
}

return 1;
}


char* ftoa(float num)
{
int i,j,c;
float num2;
double temp;
char* numtxt;
char* numtxt2;

c=0;
j=0;
num2=num;

while (modf(num,&temp) != 0)
    {
    num*=10;
    c++;
    }



 /* convert integer values to characters from right to left */

do {
    numtxt[j++] = (fmod(num,10)) + '0';
    num /= 10;
} while (num != 0);

if (num2 < 0) { numtxt[j++] = '-'; }

numtxt[j] = '\0';



if (c != 0)
    {
    strcpy(numtxt2,numtxt);
    i=strlen(numtxt)-c;
    numtxt[i]='.';
    for (j=i;j<=strlen(numtxt2);j++)
        numtxt[j+1]=numtxt2[j];
    }

return numtxt;

}


int ftoa(float num,char* numtxt)
{
int i,j,c;
float num2;
double temp;
char* numtxt2;

c=0;
j=0;
num2=num;

while (modf(num,&temp) != 0)
    {
    num*=10;
    c++;
    }



 /* convert integer values to characters from right to left */

do {
    numtxt[j++] = (fmod(num,10)) + '0';
    num /= 10;
} while (num != 0);

if (num2 < 0) { numtxt[j++] = '-'; }

numtxt[j] = '\0';



if (c != 0)
    {
    strcpy(numtxt2,numtxt);
    i=strlen(numtxt)-c;
    numtxt[i]='.';
    for (j=i;j<=strlen(numtxt2);j++)
        numtxt[j+1]=numtxt2[j];
    }

return 1;

}


char PressKey(char *Prompt,char *ErrMess,char *Options="ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890")
//Waits for a key within Options to be pressed. Returns the key pressed. If
//key pressed is not in Options then sounds a beep and displays ErrMess.
{
char Ans[1]; //string in which to store answer
cout<<Prompt; //Display the prompt
Ans[0]=getch(); //Read character from keyboard
Ans[0]=toupper(Ans[0]);
Ans[1]='\0'; //Correctly terminate string
while (!strchr(Options,Ans[0])) // Wait until valid key is pressed
 {
 cout<<endl<<ErrMess; //Display error message requesting
 Ans[0]=getch();                       //correct input
 Ans[0]=toupper(Ans[0]);
 Ans[1]='\0'; //terminate string correctly
 } //end while loop
 return Ans[0];
} //end char PressKey(..)

int ReadInt(char *Prompt,char *ErrMess)
//Displays Prompt and then enters an integer,displaying ErrMess if
//an integer was not read
{
char Input[20];
BOOL Valid;
int Value;
cout<<Prompt;
do
	{
	cin>>ws; //clear white space
	cin.getline(Input,19);
	Valid=TRUE;
	for (int Ch=0;Ch<strlen(Input);Ch++)
		if (!isdigit(Input[Ch])) //is the character not a digit
			{
			if (Input[Ch]=='-' && Ch==0) //OK to have 1st character as minus sign
				Valid=Valid;
			else
				Valid=FALSE;
			}//End if
	if (!Valid)
		cout<<ErrMess<<endl; //Display the error message
	}while(!Valid);
Value=atoi(Input);
return Value;
}//End int ReadInt(..)

float ReadFloat(char *Prompt,char *ErrMess)
{
//Reads a float (allowing minus sign and decimal point)
//Displays Prompt then reads the float
//If a valid float was not entered, displays the error message
//reads again
BOOL Valid,DecPoint;
int Ch;
char String[30];
float Number;

Valid=FALSE;
cout<<Prompt;
cin.getline(String,29);
 //Check number is a valid float within range

 while (!Valid) //Repeat until a valid number is entered
  {
  Valid=TRUE;
  DecPoint=FALSE;


  for (Ch=0;Ch<strlen(String);Ch++)
	{
	if (!isdigit(String[Ch]))
	 {
	 if (String[Ch]=='.' && !DecPoint) //Decimal point (only 1 allowed)
	  {
	  DecPoint=TRUE;
	  } //end if Sting...
	 else if (String[Ch]=='-' && Ch==0) //allow minus sign at start
		{
		Valid=Valid;
		}
	 else
	  Valid=FALSE;
	 } //end if(!isdigit)
	} //end for loop
  if (!Valid)
	cout<<ErrMess<<endl; //Display the error message
	cin.getline(String,29);
  }//end while loop

Number=atof(String);
return Number;

}//End float ReadFloat(..)

int uns2s16bit(char highbyte, char lowbyte)
{
int value,i;
i=highbyte;
if (i<0)
	{
	i&=127;
	i+=128;
	}
value=i*256;
i=lowbyte;
if (i<0)
	{
	i&=127;
	i+=128;
	}
value+=i;
return value;
}

